/* allow testing with touchpad */
#define ALLOW_TP 0

struct button_field {
	unsigned int left:1;
	unsigned int right:1;
	unsigned int middle:1;
};

struct input_data {
	int X, Y, P, touched;
	struct button_field buttons;
};

struct output_data {
	int X, Y;
	struct button_field buttons;
};

struct input_functions {
	int (*init) (void);
	void (*exit) (void);
	int (*get_data) (struct input_data *);
};

struct input_functions input_libusb, input_evdev;

struct output_functions {
	int (*init) (void);
	void (*exit) (void);
	int (*put_data) (struct output_data *);
};

struct output_functions output_uinput;

int sensitivity;

void stick2mouse(struct input_data *in, struct output_data *out);
