#include "defs.h"

#include <math.h>
#include <stdio.h>

/* see drivers/input/mouse/trackpoint.h in the kernel source
 * for the possible settings of the PS2 trackpoint */
int sensitivity = 100;

#define XMIN 1472
#define XMAX 5472
#define YMIN 1408
#define YMAX 4448

void stick2mouse(struct input_data *in, struct output_data *out)
{
	int X, Y, P;

	X = in->X;
	Y = in->Y;
	P = in->P;

	/* for testing with the touchpad */
	if (ALLOW_TP) {
		X = X - (XMIN + XMAX)/2;
		Y = Y - (YMIN + YMAX)/2;
		X = (X * 2 * 127) / (XMAX - XMIN);
		Y = - (Y * 2 * 127) / (YMAX - YMIN);
		P = (in->P * 16) / 80;
	}

	if (in->touched) {
		out->X = (int)round(
			( (double)X * (double)sensitivity*100
			* pow((double)(P - 3), 4) ) / (500*50*5*5*5*5));
		out->Y = (int)round(
			( (double)Y * (double)sensitivity*100
			* pow((double)(P - 3), 4) ) / (500*50*5*5*5*5));
	} else {
		out->X = 0;
		out->Y = 0;
	}

	out->buttons = in->buttons;
}
